<?php
// XI Core Ajax Helper Functions
//
// Copyright (c) 2008-2009 Nagios Enterprises, LLC.  All rights reserved.
//  
// $Id: ajaxhelpers-status.inc.php 360 2010-10-31 18:32:47Z egalstad $

include_once(dirname(__FILE__).'/../componenthelper.inc.php');
	

////////////////////////////////////////////////////////////////////////
// TAC AJAX FUNCTIONS
////////////////////////////////////////////////////////////////////////

function xicore_ajax_get_network_outages_summary_html($args=null){
	global $lstr;
	
	$mode=grab_array_var($args,"mode");
	
	$admin=is_admin();
	
	$output='';

	//$output.='<div class="infotable_title">Network Outages</div>';
	
	$url="outages-xml.cgi";
	$cgioutput=coreui_get_raw_cgi_output($url,array());
	//$output.=serialize($cgioutput);
	$xml=simplexml_load_string($cgioutput);
	//echo "THE XML<BR>";
	//print_r($xml);
	if(!$xml){
		$output.='
		<table class="standardtable">
		<thead>
		<tr><th>'.gettext('Network Outages').'</th></tr>
		</thead>
		<tbody>
		';
		$text="";
		$text.=gettext("Monitoring engine may be stopped.");
		if($admin==true)
			$text.="<br><a href='".get_base_url()."admin/sysstat.php'>".gettext('Check engine')."</a>";
		$output.="<tr><td class='tacoutageImportantProblem'><b>".gettext('Error: Unable to parse XML output!')."</b><br>".$text."</td></tr>";
		$output.='
		</tbody>
		</table>
		';
		//$output.=$cgioutput;
		}
	else{
		$output.='
		<table class="standardtable">
		<thead>
		<tr><th>'.gettext('Network Outages').'</th></tr>
		</thead>
		<tbody>
		';

		
		$total=0;
		foreach($xml->hostoutage as $ho){
			$total++;
			}
			
		$url=get_base_url()."includes/components/xicore/status.php?show=outages";

		$output.='<tr class="tacSubHeader"><td><a href="'.$url.'">'.$total.' '.gettext('Outages').'</a></td></tr>';
			
		if($total==0)
			$output.='<tr><td>'.gettext('No Blocking Outages').'</td></tr>';
		else{
			$output.='<tr><td><div class="tacoutageImportantProblem"><a href="'.$url.'">'.$total.' '.gettext('Blocking Outages').'</a></div></td></tr>';
			}
			
		$output.='
		</tbody>
		</table>
		';
		}

	if($mode==DASHLET_MODE_INBOARD){
		$output.='
		<div class="ajax_date">'.gettext('Last Updated').': '.get_datetime_string(time()).'</div>
		';
		}
	
	return $output;
	}

function xicore_ajax_get_network_health_html($args=null){
	global $lstr;
	
	//$start = timer_start(); 
	
	$ignore_soft_states=grab_array_var($args,"ignore_soft_states");
	$host_warning_threshold=grab_array_var($args,"host_warning_threshold");
	$host_critical_threshold=grab_array_var($args,"host_critical_threshold");
	$service_warning_threshold=grab_array_var($args,"service_warning_threshold");
	$service_critical_threshold=grab_array_var($args,"servicet_critical_threshold");
	
	$output='';

	// get host status
	$hosts_ok=0;
	$hosts_notok=0;
	$total_hosts=0;
	
	//get total number of hosts
	$backendargs=array();
	$backendargs["cmd"]="gethoststatus";
	$backendargs["totals"]=1; 
	$xml=get_xml_host_status($backendargs);
	
	//array_dump($xml); 
	if($xml)
		$total_hosts=intval($xml->recordcount); 	
	
	//get the total number of problems
	$backendargs["current_state"]="in:1,2";
	if($ignore_soft_states==1) //ignore soft states?
		$backendargs["state_type"]=1;
	$xml=get_xml_host_status($backendargs);	
	//array_dump($xml); 
	if($xml)
		$total_notok=intval($xml->recordcount);
			
	$hosts_ok = $total_hosts - $total_notok; 	
	
		
	if($total_hosts==0)
		$health_percent=0;
	else
		$health_percent=($hosts_ok/$total_hosts)*100;
		
	$val=intval($health_percent);
	
	//begin html build 
	$output.='
	<table class="standardtable">
	<thead>
	<tr><th colspan="2">'.gettext('Network Health').'</th></tr>
	</thead>
	<tbody>
	';
	
	$url=get_base_url()."includes/components/xicore/status.php?show=hosts";
	$content="<a href='".$url."'>".$val."%</a>";

	if($health_percent < $host_critical_threshold)
		$spanval="<div style='height: 15px; width: ".$val."px; background-color:  ".COMMONCOLOR_RED.";'>".$content."</div>";
	else if($health_percent < $host_warning_threshold)
		$spanval="<div style='height: 15px; width: ".$val."px; background-color:  ".COMMONCOLOR_YELLOW.";'>".$content."</div>";
	else
		$spanval="<div style='height: 15px; width: ".$val."px; background-color:  ".COMMONCOLOR_GREEN.";'>".$content."</div>";
	
	$output.='<tr><td><b>'.gettext('Host Health').'</b></td><td width="100px"><span class="statbar">'.$spanval.'</span></td></tr>';
	
		
	// getservicestatus
	$services_ok=0;
	$services_notok=0;
	$services_hosts=0;
	
	//get total number of hosts
	$backendargs=array();
	$backendargs["cmd"]="getservicestatus";
	$backendargs["totals"]=1; 
	$xml=get_xml_service_status($backendargs);
	
	//array_dump($xml); 
	if($xml)
		$total_services=intval($xml->recordcount); 
	
	//get the total number of problems
	$backendargs["current_state"]="in:1,2,3";
	if($ignore_soft_states==1) //ignore soft states?
		$backendargs["state_type"]=1;
	$xml=get_xml_service_status($backendargs);	
	//array_dump($xml); 
	if($xml)
		$total_notok=intval($xml->recordcount);	
	
	$services_ok = $total_services - $total_notok;

	//calculate percentage	
	if($total_services==0)
		$health_percent=0;
	else
		$health_percent=($services_ok/$total_services)*100;
		
	$val=intval($health_percent);
	
	$url=get_base_url()."includes/components/xicore/status.php?show=services";
	$content="<a href='".$url."'>".$val."%</a>";

	if($health_percent < $service_critical_threshold)
		$spanval="<div style='height: 15px; width: ".$val."px; background-color:  ".COMMONCOLOR_RED.";'>".$content."</div>";
	else if($health_percent < $service_warning_threshold)
		$spanval="<div style='height: 15px; width: ".$val."px; background-color:  ".COMMONCOLOR_YELLOW.";'>".$content."</div>";
	else
		$spanval="<div style='height: 15px; width: ".$val."px; background-color:  ".COMMONCOLOR_GREEN.";'>".$content."</div>";
	
	$output.='<tr><td><b>'.gettext('Service Health').'</b></td><td width="100px"><span class="statbar">'.$spanval.'</span></td></tr>';
	
		

	$output.='
	</tbody>
	</table>
	';

	//if($mode==DASHLET_MODE_INBOARD){
		$output.='
		<div class="ajax_date">'.gettext('Last Updated').': '.get_datetime_string(time()).'</div>
		';
	//	}
	
	//debug
	//echo timer_stop($start); 
	
	return $output;
	}
	
function xicore_ajax_get_host_status_tac_summary_html($args=null){
	global $lstr;
	
	//$start = timer_start(); 
	
	$mode=grab_array_var($args,"mode");
	$ignore_soft_states=grab_array_var($args,"ignore_soft_states");
	
	$base_url=get_base_url()."includes/components/xicore/status.php?show=hosts";
		
	//fetch totals from backend -> New as of 1/7/2012 - MG	
	$info = get_host_status_tac_summary_data(false,array(),true);	
	
	//begin building html output
	$output='';

	$output.='
	<table class="standardtable">
	<thead>
	<tr><th colspan="4">Hosts</th></tr>
	</thead>
	<tbody>
	';
	
	$output.='<tr class="tacSubHeader">';
	$output.='<td width="135"><a href="'.$base_url.'&hoststatustypes='.HOSTSTATE_DOWN.'">'.$info["down"]["total"].' '.gettext('Down').'</a></td>';
	$output.='<td width="135"><a href="'.$base_url.'&hoststatustypes='.HOSTSTATE_UNREACHABLE.'">'.$info["unreachable"]["total"].' '.gettext('Unreachable').'</a></td>';
	$output.='<td width="135"><a href="'.$base_url.'&hoststatustypes='.HOSTSTATE_UP.'">'.$info["up"]["total"].' '.gettext('Up').'</a></td>';
	$output.='<td width="135"><a href="'.$base_url.'&hoststatustypes='.HOSTSTATE_PENDING.'">'.$info["pending"]["total"].' '.gettext('Pending').'</a></td>';
	$output.='</tr>';
	
	$output.='<tr>';
	
	// down
	$output.='<td>';	
	if($info["down"]["unhandled"]){
		$output.='<div class="tachostImportantProblem"><a href="'.$base_url.'&hoststatustypes='.HOSTSTATE_DOWN.'&hostattr='.(HOSTSTATUSATTR_NOTINDOWNTIME|HOSTSTATUSATTR_NOTACKNOWLEDGED).'">'.$info["down"]["unhandled"].' '.gettext('Unhandled Problems').'</a></div>';
		}
	if($info["down"]["acknowledged"]){
		$output.='<div class="tachostProblem"><a href="'.$base_url.'&hoststatustypes='.HOSTSTATE_DOWN.'&hostattr=4">'.$info["down"]["acknowledged"].''.gettext(' Acknowledged').'</a></div>';
		}
	if($info["down"]["scheduled"]){
		$output.='<div class="tachostProblem"><a href="'.$base_url.'&hoststatustypes='.HOSTSTATE_DOWN.'&hostattr=1">'.$info["down"]["scheduled"].' '.gettext('Scheduled').'</a></div>';
		}
	if($info["down"]["active"]){
		$output.='<div class="tachostProblem"><a href="'.$base_url.'&hoststatustypes='.HOSTSTATE_DOWN.'&hostattr='.(HOSTSTATUSATTR_CHECKSENABLED).'">'.$info["down"]["active"].' '.gettext('Active').'</a></div>';
		}
	if($info["down"]["disabled"]){
		$output.='<div class="tachostProblem"><a href="'.$base_url.'&hoststatustypes='.HOSTSTATE_DOWN.'&hostattr='.(HOSTSTATUSATTR_CHECKSDISABLED|HOSTSTATUSATTR_PASSIVECHECKSENABLED).'">'.$info["down"]["disabled"].' '.gettext('Passive').'</a></div>';
		}
	if($info["down"]["soft"]){
		$output.='<div class="tachostProblem"><a href="'.$base_url.'&hoststatustypes='.HOSTSTATE_DOWN.'&hostattr=524288">'.$info["down"]["soft"].' '.gettext('Soft Problems').'</a></div>';
		}
	$output.='</td>';
	
	// unreachable
	$output.='<td>';
	if($info["unreachable"]["unhandled"]){
		$output.='<div class="tachostImportantProblem"><a href="'.$base_url.'&hoststatustypes='.HOSTSTATE_UNREACHABLE.'&hostattr='.(HOSTSTATUSATTR_NOTINDOWNTIME|HOSTSTATUSATTR_NOTACKNOWLEDGED).'">'.$info["unreachable"]["unhandled"].' '.gettext('Unhandled Problems').'</a></div>';
		}
	if($info["unreachable"]["acknowledged"]){
		$output.='<div class="tachostProblem"><a href="'.$base_url.'&hoststatustypes='.HOSTSTATE_UNREACHABLE.'&hostattr=4">'.$info["unreachable"]["acknowledged"].' '.gettext('Acknowledged').'</a></div>';
		}
	if($info["unreachable"]["scheduled"]){
		$output.='<div class="tachostProblem"><a href="'.$base_url.'&hoststatustypes='.HOSTSTATE_UNREACHABLE.'&hostattr=1">'.$info["unreachable"]["scheduled"].' '.gettext('Scheduled').'</a></div>';
		}
	if($info["unreachable"]["active"]){
		$output.='<div class="tachostProblem"><a href="'.$base_url.'&hoststatustypes='.HOSTSTATE_UNREACHABLE.'&hostattr='.(HOSTSTATUSATTR_CHECKSENABLED).'">'.$info["unreachable"]["active"].' '.gettext('Active').'</a></div>';
		}
	if($info["unreachable"]["disabled"]){
		$output.='<div class="tachostProblem"><a href="'.$base_url.'&hoststatustypes='.HOSTSTATE_UNREACHABLE.'&hostattr='.(HOSTSTATUSATTR_CHECKSDISABLED|HOSTSTATUSATTR_PASSIVECHECKSENABLED).'">'.$info["unreachable"]["disabled"].' '.gettext('Passive').'</a></div>';
		}
	if($info["unreachable"]["soft"]){
		$output.='<div class="tachostProblem"><a href="'.$base_url.'&hoststatustypes='.HOSTSTATE_UNREACHABLE.'&hostattr=524288">'.$info["unreachable"]["soft"].' '.gettext('Soft Problems').'</a></div>';
		}
	$output.='</td>';

	// up
	$output.='<td>';
	if($info["up"]["scheduled"]){
		$output.='<div class="tachostNoProblem"><a href="'.$base_url.'&hoststatustypes='.HOSTSTATE_UP.'&hostattr=1">'.$info["up"]["scheduled"].' '.gettext('Scheduled').'</a></div>';
		}
	if($info["up"]["active"]){
		$output.='<div class="tachostNoProblem"><a href="'.$base_url.'&hoststatustypes='.HOSTSTATE_UP.'&hostattr='.(HOSTSTATUSATTR_CHECKSENABLED).'">'.$info["up"]["active"].' '.gettext('Active').'</a></div>';
		}
	if($info["up"]["disabled"]){
		$output.='<div class="tachostNoProblem"><a href="'.$base_url.'&hoststatustypes='.HOSTSTATE_UP.'&hostattr='.(HOSTSTATUSATTR_CHECKSDISABLED|HOSTSTATUSATTR_PASSIVECHECKSENABLED).'">'.$info["up"]["disabled"].' '.gettext('Passive').'</a></div>';
		}
	$output.='</td>';

	// pending
	$output.='<td>';
	if($info["pending"]["scheduled"]){
		$output.='<div class="tachostNoProblem"><a href="'.$base_url.'&hoststatustypes='.HOSTSTATE_PENDING.'&hostattr=1">'.$info["pending"]["scheduled"].' '.gettext('Scheduled').'</a></div>';
		}
	if($info["pending"]["active"]){
		$output.='<div class="tachostNoProblem"><a href="'.$base_url.'&hoststatustypes='.HOSTSTATE_PENDING.'&hostattr='.(HOSTSTATUSATTR_CHECKSENABLED).'">'.$info["pending"]["active"].' '.gettext('Active').'</a></div>';
		}
	if($info["pending"]["disabled"]){
		$output.='<div class="tachostNoProblem"><a href="'.$base_url.'&hoststatustypes='.HOSTSTATE_PENDING.'&hostattr='.(HOSTSTATUSATTR_CHECKSDISABLED|HOSTSTATUSATTR_PASSIVECHECKSENABLED).'">'.$info["pending"]["disabled"].' '.gettext('Passive').'</a></div>';
		}
	$output.='</td>';

	$output.='</tr>';

	$output.='
	</tbody>
	</table>
	';

	if($mode==DASHLET_MODE_INBOARD){
		$output.='
		<div class="ajax_date">'.gettext('Last Updated').': '.get_datetime_string(time()).'</div>
		';
		}
	
	//echo timer_stop($start); 
	
	return $output;
	}
	
function xicore_ajax_get_service_status_tac_summary_html($args=null){
	global $lstr;
	
	//$start = timer_start(); 
	
	$mode=grab_array_var($args,"mode");
	$ignore_soft_states=grab_array_var($args,"ignore_soft_states");
	
	$base_url=get_base_url()."includes/components/xicore/status.php?show=services";
	
	//fetch totals from backend -> New as of 1/7/2012 - MG
	$info = get_service_status_tac_summary_data(false,array(),true);

	//begin building html output
	$output='';

	$output.='
	<table class="standardtable">
	<thead>
	<tr><th colspan="5">'.gettext('Services').'</th></tr>
	</thead>
	<tbody>
	';
	
	$output.='<tr class="tacSubHeader">';
	$output.='<td width="135"><a href="'.$base_url.'&servicestatustypes='.SERVICESTATE_CRITICAL.'">'.$info["critical"]["total"].' '.gettext('Critical').'</a></td>';
	$output.='<td width="135"><a href="'.$base_url.'&servicestatustypes='.SERVICESTATE_WARNING.'">'.$info["warning"]["total"].' '.gettext('Warning').'</a></td>';
	$output.='<td width="135"><a href="'.$base_url.'&servicestatustypes='.SERVICESTATE_UNKNOWN.'">'.$info["unknown"]["total"].' '.gettext('Unknown').'</a></td>';
	$output.='<td width="135"><a href="'.$base_url.'&servicestatustypes='.SERVICESTATE_OK.'">'.$info["ok"]["total"].' '.gettext('Ok').'</a></td>';
	$output.='<td width="135"><a href="'.$base_url.'&servicestatustypes='.SERVICESTATE_PENDING.'">'.$info["pending"]["total"].' '.gettext('Pending').'</a></td>';
	$output.='</tr>';

	$output.='<tr>';
	
	// critical
	$output.='<td>';	
	if($info["critical"]["unhandled"]){
		$output.='<div class="tacserviceImportantProblem"><a href="'.$base_url.'&servicestatustypes='.SERVICESTATE_CRITICAL.'&serviceattr='.(SERVICESTATUSATTR_NOTINDOWNTIME|SERVICESTATUSATTR_NOTACKNOWLEDGED).'&hoststatustypes=3">'.$info["critical"]["unhandled"].' '.gettext('Unhandled Problems').'</a></div>';
		}
	if($info["critical"]["hostproblem"]){
		$output.='<div class="tacserviceProblem"><a href="'.$base_url.'&servicestatustypes='.SERVICESTATE_CRITICAL.'&hoststatustypes=12">'.$info["critical"]["hostproblem"].' '.gettext('On Problem Hosts').'</a></div>';
		}
	if($info["critical"]["acknowledged"]){
		$output.='<div class="tacserviceProblem"><a href="'.$base_url.'&servicestatustypes='.SERVICESTATE_CRITICAL.'&serviceattr=4">'.$info["critical"]["acknowledged"].' '.gettext('Acknowledged').'</a></div>';
		}
	if($info["critical"]["scheduled"]){
		$output.='<div class="tacserviceProblem"><a href="'.$base_url.'&servicestatustypes='.SERVICESTATE_CRITICAL.'&serviceattr=1">'.$info["critical"]["scheduled"].' '.gettext('Scheduled').'</a></div>';
		}
	if($info["critical"]["active"]){
		$output.='<div class="tacserviceProblem"><a href="'.$base_url.'&servicestatustypes='.SERVICESTATE_CRITICAL.'&serviceattr='.(SERVICESTATUSATTR_CHECKSENABLED).'">'.$info["critical"]["active"].' '.gettext('Active').'</a></div>';
		}
	if($info["critical"]["disabled"]){
		$output.='<div class="tacserviceProblem"><a href="'.$base_url.'&servicestatustypes='.SERVICESTATE_CRITICAL.'&serviceattr='.(SERVICESTATUSATTR_CHECKSDISABLED|SERVICESTATUSATTR_PASSIVECHECKSENABLED).'">'.$info["critical"]["disabled"].' '.gettext('Passive').'</a></div>';
		}
	if($info["critical"]["soft"]){
		$output.='<div class="tacserviceProblem"><a href="'.$base_url.'&servicestatustypes='.SERVICESTATE_CRITICAL.'&serviceattr=524288">'.$info["critical"]["soft"].' '.gettext('Soft Problems').'</a></div>';
		}
	$output.='</td>';
	
	// warning
	$output.='<td>';	
	if($info["warning"]["unhandled"]){
		$output.='<div class="tacserviceImportantWarning"><a href="'.$base_url.'&servicestatustypes='.SERVICESTATE_WARNING.'&serviceattr='.(SERVICESTATUSATTR_NOTINDOWNTIME|SERVICESTATUSATTR_NOTACKNOWLEDGED).'&hoststatustypes=3">'.$info["warning"]["unhandled"].' '.gettext('Unhandled Problems').'</a></div>';
		}
	if($info["warning"]["hostproblem"]){
		$output.='<div class="tacserviceProblemWarning"><a href="'.$base_url.'&servicestatustypes='.SERVICESTATE_WARNING.'&hoststatustypes=12">'.$info["warning"]["hostproblem"].' '.gettext('On Problem Hosts').'</a></div>';
		}
	if($info["warning"]["acknowledged"]){
		$output.='<div class="tacserviceProblemWarning"><a href="'.$base_url.'&servicestatustypes='.SERVICESTATE_WARNING.'&serviceattr=4">'.$info["warning"]["acknowledged"].' '.gettext('Acknowledged').'</a></div>';
		}
	if($info["warning"]["scheduled"]){
		$output.='<div class="tacserviceProblemWarning"><a href="'.$base_url.'&servicestatustypes='.SERVICESTATE_WARNING.'&serviceattr=1">'.$info["warning"]["scheduled"].' '.gettext('Scheduled').'</a></div>';
		}
	if($info["warning"]["active"]){
		$output.='<div class="tacserviceProblemWarning"><a href="'.$base_url.'&servicestatustypes='.SERVICESTATE_WARNING.'&serviceattr='.(SERVICESTATUSATTR_CHECKSENABLED).'">'.$info["warning"]["active"].' '.gettext('Active').'</a></div>';
		}
	if($info["warning"]["disabled"]){
		$output.='<div class="tacserviceProblemWarning"><a href="'.$base_url.'&servicestatustypes='.SERVICESTATE_WARNING.'&serviceattr='.(SERVICESTATUSATTR_CHECKSDISABLED|SERVICESTATUSATTR_PASSIVECHECKSENABLED).'">'.$info["warning"]["disabled"].' '.gettext('Passive').'</a></div>';
		}
	if($info["warning"]["soft"]){
		$output.='<div class="tacserviceProblemWarning"><a href="'.$base_url.'&servicestatustypes='.SERVICESTATE_WARNING.'&serviceattr=524288">'.$info["warning"]["soft"].' '.gettext('Soft Problems').'</a></div>';
		}
	$output.='</td>';
	
	// unknown
	$output.='<td>';	
	if($info["unknown"]["unhandled"]){
		$output.='<div class="tacserviceImportantUnknown"><a href="'.$base_url.'&servicestatustypes='.SERVICESTATE_UNKNOWN.'&serviceattr='.(SERVICESTATUSATTR_NOTINDOWNTIME|SERVICESTATUSATTR_NOTACKNOWLEDGED).'&hoststatustypes=3">'.$info["unknown"]["unhandled"].' '.gettext('Unhandled Problems').'</a></div>';
		}
	if($info["unknown"]["hostproblem"]){
		$output.='<div class="tacserviceProblemUnknown"><a href="'.$base_url.'&servicestatustypes='.SERVICESTATE_UNKNOWN.'&hoststatustypes=12">'.$info["unknown"]["hostproblem"].' '.gettext('On Problem Hosts').'</a></div>';
		}
	if($info["unknown"]["acknowledged"]){
		$output.='<div class="tacserviceProblemUnknown"><a href="'.$base_url.'&servicestatustypes='.SERVICESTATE_UNKNOWN.'&serviceattr=4">'.$info["unknown"]["acknowledged"].' '.gettext('Acknowledged').'</a></div>';
		}
	if($info["unknown"]["scheduled"]){
		$output.='<div class="tacserviceProblemUnknown"><a href="'.$base_url.'&servicestatustypes='.SERVICESTATE_UNKNOWN.'&serviceattr=1">'.$info["unknown"]["scheduled"].' '.gettext('Scheduled').'</a></div>';
		}
	if($info["unknown"]["active"]){
		$output.='<div class="tacserviceProblemUnknown"><a href="'.$base_url.'&servicestatustypes='.SERVICESTATE_UNKNOWN.'&serviceattr='.(SERVICESTATUSATTR_CHECKSENABLED).'">'.$info["unknown"]["active"].' '.gettext('Active').'</a></div>';
		}
	if($info["unknown"]["disabled"]){
		$output.='<div class="tacserviceProblemUnknown"><a href="'.$base_url.'&servicestatustypes='.SERVICESTATE_UNKNOWN.'&serviceattr='.(SERVICESTATUSATTR_CHECKSDISABLED|SERVICESTATUSATTR_PASSIVECHECKSENABLED).'">'.$info["unknown"]["disabled"].' '.gettext('Passive').'</a></div>';
		}
	if($info["unknown"]["soft"]){
		$output.='<div class="tacserviceProblemUnknown"><a href="'.$base_url.'&servicestatustypes='.SERVICESTATE_UNKNOWN.'&serviceattr=524288">'.$info["unknown"]["soft"].' '.gettext('Soft Problems').'</a></div>';
		}
	$output.='</td>';
	
	// ok
	$output.='<td>';	
	if($info["ok"]["scheduled"]){
		$output.='<div class="tacserviceNoProblem"><a href="'.$base_url.'&servicestatustypes='.SERVICESTATE_OK.'&serviceattr=1">'.$info["ok"]["scheduled"].' '.gettext('Scheduled').'</a></div>';
		}
	if($info["ok"]["active"]){
		$output.='<div class="tacserviceNoProblem"><a href="'.$base_url.'&servicestatustypes='.SERVICESTATE_OK.'&serviceattr='.(SERVICESTATUSATTR_CHECKSENABLED).'">'.$info["ok"]["active"].' '.gettext('Active').'</a></div>';
		}
	if($info["ok"]["disabled"]){
		$output.='<div class="tacserviceNoProblem"><a href="'.$base_url.'&servicestatustypes='.SERVICESTATE_OK.'&serviceattr='.(SERVICESTATUSATTR_CHECKSDISABLED|SERVICESTATUSATTR_PASSIVECHECKSENABLED).'">'.$info["ok"]["disabled"].' '.gettext('Passive').'</a></div>';
		}
	$output.='</td>';

	// pending
	$output.='<td>';	
	if($info["pending"]["scheduled"]){
		$output.='<div class="tacserviceNoProblem"><a href="'.$base_url.'&servicestatustypes='.SERVICESTATE_PENDING.'&serviceattr=1">'.$info["pending"]["scheduled"].' '.gettext('Scheduled').'</a></div>';
		}
	if($info["pending"]["active"]){
		$output.='<div class="tacserviceNoProblem"><a href="'.$base_url.'&servicestatustypes='.SERVICESTATE_PENDING.'&serviceattr='.(SERVICESTATUSATTR_CHECKSENABLED).'">'.$info["pending"]["active"].' '.gettext('Active').'</a></div>';
		}
	if($info["pending"]["disabled"]){
		$output.='<div class="tacserviceNoProblem"><a href="'.$base_url.'&servicestatustypes='.SERVICESTATE_PENDING.'&serviceattr='.(SERVICESTATUSATTR_CHECKSDISABLED|SERVICESTATUSATTR_PASSIVECHECKSENABLED).'">'.$info["pending"]["disabled"].' '.gettext('Passive').'</a></div>';
		}
	$output.='</td>';

	$output.='</tr>';

	$output.='
	</tbody>
	</table>
	';

	if($mode==DASHLET_MODE_INBOARD){
		$output.='
		<div class="ajax_date">'.gettext('Last Updated:').' '.get_datetime_string(time()).'</div>
		';
		}
	
	//echo timer_stop($start); 
	
	return $output;
	}
	
function xicore_ajax_get_feature_status_tac_summary_html($args=null){
	global $lstr;
	
	//$start = timer_start(); 
	
	$mode=grab_array_var($args,"mode");
	
	$flap_detection_enabled=0;
	$active_checks_enabled=0;
	$passive_checks_enabled=0;
	$notifications_enabled=0;
	$event_handlers_enabled=0;
	
	// get program status
	$backendargs=array();
	$backendargs["cmd"]="getprogramstatus";
	$xml=get_xml_program_status($backendargs);
	if($xml){
		$flap_detection_enabled=intval($xml->programstatus->flap_detection_enabled);
		$active_checks_enabled=intval($xml->programstatus->active_service_checks_enabled);
		$passive_checks_enabled=intval($xml->programstatus->passive_service_checks_enabled);
		$notifications_enabled=intval($xml->programstatus->notifications_enabled);
		$event_handlers_enabled=intval($xml->programstatus->event_handlers_enabled);
		}
	
	
	// get service status totals
	$backendargs=array(
		"cmd" => "getservicestatus",
		"totals" => 1,
		"is_active" => 1,
		); 
	
	//flap detection?
	$backendargs["flap_detection_enabled"] = 0; 
	$xml=get_xml_service_status($backendargs);
	$services_flap_detection_disabled = ($xml) ? intval($xml->recordcount) : 0;
	unset($backendargs["flap_detection_enabled"]); 
	
	//services flapping
	$backendargs["is_flapping"] = 1; 
	$xml=get_xml_service_status($backendargs);
	$services_flapping = ($xml) ? intval($xml->recordcount) : 0;
	unset($backendargs["is_flapping"]); 

	//services notifications disabled
	$backendargs["notifications_enabled"] = 0; 
	$xml=get_xml_service_status($backendargs);
	$services_notifications_disabled = ($xml) ? intval($xml->recordcount) : 0;
	unset($backendargs["notifications_enabled"]); 	
	
	//services event handler disabled
	$backendargs["event_handler_enabled"] = 0; 
	$xml=get_xml_service_status($backendargs);
	$services_event_handlers_disabled = ($xml) ? intval($xml->recordcount) : 0;
	unset($backendargs["event_handler_enabled"]); 	
	
	//services active checks disabled
	$backendargs["active_checks_enabled"] = 0; 
	$backendargs["passive_checks_enabled"] = 0; 
	$xml=get_xml_service_status($backendargs);
	$services_active_checks_disabled = ($xml) ? intval($xml->recordcount) : 0;
	unset($backendargs["active_checks_enabled"]); 
	unset($backendargs["passive_checks_enabled"]); 

	//services passive checks disabled
	$backendargs["passive_checks_enabled"] = 0; 
	$xml=get_xml_service_status($backendargs);
	$services_passive_checks_disabled = ($xml) ? intval($xml->recordcount) : 0;
	unset($backendargs["passive_checks_enabled"]); 
	
	//services active checks disabled
	$backendargs["passive_checks_enabled"] = 0; 
	$xml=get_xml_service_status($backendargs);
	$services_passive_checks_disabled = ($xml) ? intval($xml->recordcount) : 0;
	unset($backendargs["passive_checks_enabled"]);
	
	//////////////////////////
	// get host status totals
	$backendargs=array(
		"cmd" => "gethoststatus",
		"totals" => 1,
		"is_active" => 1,
		); 
	
	//flap detection?
	$backendargs["flap_detection_enabled"] = 0; 
	$xml=get_xml_host_status($backendargs);
	$hosts_flap_detection_disabled = ($xml) ? intval($xml->recordcount) : 0;
	unset($backendargs["flap_detection_enabled"]); 
	
	//hosts flapping
	$backendargs["is_flapping"] = 1; 
	$xml=get_xml_host_status($backendargs);
	$hosts_flapping = ($xml) ? intval($xml->recordcount) : 0;
	unset($backendargs["is_flapping"]); 

	//hosts notifications disabled
	$backendargs["notifications_enabled"] = 0; 
	$xml=get_xml_host_status($backendargs);
	$hosts_notifications_disabled = ($xml) ? intval($xml->recordcount) : 0;
	unset($backendargs["notifications_enabled"]); 	
	
	//hosts event handler disabled
	$backendargs["event_handler_enabled"] = 0; 
	$xml=get_xml_host_status($backendargs);
	$hosts_event_handlers_disabled = ($xml) ? intval($xml->recordcount) : 0;
	unset($backendargs["event_handler_enabled"]); 	
	
	//hosts active checks disabled
	$backendargs["active_checks_enabled"] = 0; 
	$backendargs["passive_checks_enabled"] = 0; 
	$xml=get_xml_host_status($backendargs);
	$hosts_active_checks_disabled = ($xml) ? intval($xml->recordcount) : 0;
	unset($backendargs["active_checks_enabled"]); 
	unset($backendargs["passive_checks_enabled"]); 

	//hosts passive checks disabled
	$backendargs["passive_checks_enabled"] = 0; 
	$xml=get_xml_host_status($backendargs);
	$hosts_passive_checks_disabled = ($xml) ? intval($xml->recordcount) : 0;
	unset($backendargs["passive_checks_enabled"]); 
	
	//hosts active checks disabled
	$backendargs["passive_checks_enabled"] = 0; 
	$xml=get_xml_host_status($backendargs);
	$hosts_passive_checks_disabled = ($xml) ? intval($xml->recordcount) : 0;
	unset($backendargs["passive_checks_enabled"]);
	

	//begin building html output
	$output='';

	$output.='
	<table class="standardtable">
	<thead>
	<tr><th colspan="10">'.gettext('Features').'</th></tr>
	</thead>
	<tbody>
	';
	
	$output.='<tr class="tacSubHeader"><td colspan="2">'.gettext('Flap Detection').'</td><td colspan="2">'.gettext('Notifications').'</td><td colspan="2">'.gettext('Event Handlers').'</td><td colspan="2">'.gettext('Active Checks').'</td><td colspan="2">'.gettext('Passive Checks').'</td></tr>';
	
	$output.='<tr>';
	
	$process_status_url=get_base_url()."includes/components/xicore/status.php?show=process";
	
	$status_url=get_base_url()."includes/components/xicore/status.php";

	// flap detection
	$output.='<td><a href="'.$process_status_url.'"><img src="'.theme_image(($flap_detection_enabled==0)?"tacdisabled.png":"tacenabled.png").'"></a></td>';
	$output.='<td width="135">';
	if($flap_detection_enabled==0){
		$output.='<div class="tacfeatureNoProblem">N/A</div>';
		}
	else{
		if($services_flap_detection_disabled>0)
			$output.='<div class="tacfeatureNoProblem"><a href="'.$status_url.'?show=services&serviceattr=256">'.$services_flap_detection_disabled.' '.gettext('Services Disabled').'</a></div>';
		else
			$output.='<div class="tacfeatureNoProblem">'.gettext('All Services Enabled').'</div>';
		if($services_flapping>0)
			$output.='<div class="tacfeatureProblem"><a href="'.$status_url.'?show=services&serviceattr=1024">'.$services_flapping.' '.gettext('Services Flapping').'</a></div>';
		if($hosts_flap_detection_disabled>0)
			$output.='<div class="tacfeatureNoProblem"><a href="'.$status_url.'?show=hosts&hostattr=256">'.$hosts_flap_detection_disabled.' '.gettext('Hosts Disabled').'</a></div>';
		else
			$output.='<div class="tacfeatureNoProblem">'.gettext('All Hosts Enabled').'</div>';
		if($hosts_flapping>0)
			$output.='<div class="tacfeatureProblem"><a href="'.$status_url.'?show=hosts&hostattr=1024">'.$hosts_flapping.' '.gettext('Hosts Flapping').'</a></div>';
		}
	$output.='</td>';
	
	// notifications
	$output.='<td><a href="'.$process_status_url.'"><img src="'.theme_image(($notifications_enabled==0)?"tacdisabled.png":"tacenabled.png").'"></a></td>';
	$output.='<td width="135">';
	if($notifications_enabled==0){
		$output.='<div class="tacfeatureNoProblem">N/A</div>';
		}
	else{
		if($services_notifications_disabled>0)
			$output.='<div class="tacfeatureNoProblem"><a href="'.$status_url.'?show=services&serviceattr=4096">'.$services_notifications_disabled.' '.gettext('Services Disabled').'</a></div>';
		else
			$output.='<div class="tacfeatureNoProblem">'.gettext('All Services Enabled').'</div>';
		if($hosts_notifications_disabled>0)
			$output.='<div class="tacfeatureNoProblem"><a href="'.$status_url.'?show=hosts&hostattr=4096">'.$hosts_notifications_disabled.' '.gettext('Hosts Disabled').'</a></div>';
		else
			$output.='<div class="tacfeatureNoProblem">'.gettext('All Hosts Enabled').'</div>';
		}
	$output.='</td>';

	// event handlers
	$output.='<td><a href="'.$process_status_url.'"><img src="'.theme_image(($event_handlers_enabled==0)?"tacdisabled.png":"tacenabled.png").'"></a></td>';
	$output.='<td width="135">';
	if($event_handlers_enabled==0){
		$output.='<div class="tacfeatureNoProblem">N/A</div>';
		}
	else{
		if($services_event_handlers_disabled>0)
			$output.='<div class="tacfeatureNoProblem"><a href="'.$status_url.'?show=services&serviceattr=64">'.$services_event_handlers_disabled.' '.gettext('Services Disabled').'</a></div>';
		else
			$output.='<div class="tacfeatureNoProblem">'.gettext('All Services Enabled').'</div>';
		if($hosts_event_handlers_disabled>0)
			$output.='<div class="tacfeatureNoProblem"><a href="'.$status_url.'?show=hosts&hostattr=64">'.$hosts_event_handlers_disabled.' '.gettext('Hosts Disabled').'</a></div>';
		else
			$output.='<div class="tacfeatureNoProblem">'.gettext('All Hosts Enabled').'</div>';
		}
	$output.='</td>';

	// active checks
	$output.='<td><a href="'.$process_status_url.'"><img src="'.theme_image(($active_checks_enabled==0)?"tacdisabled.png":"tacenabled.png").'"></a></td>';
	$output.='<td width="135">';
	if($active_checks_enabled==0){
		$output.='<div class="tacfeatureNoProblem">N/A</div>';
		}
	else{
		if($services_active_checks_disabled>0)
			$output.='<div class="tacfeatureNoProblem"><a href="'.$status_url.'?show=services&serviceattr=16400">'.$services_active_checks_disabled.' '.gettext('Services Disabled').'</a></div>';
		else
			$output.='<div class="tacfeatureNoProblem">'.gettext('All Services Enabled').'</div>';
		if($hosts_active_checks_disabled>0)
			$output.='<div class="tacfeatureNoProblem"><a href="'.$status_url.'?show=hosts&hostattr=16">'.$hosts_active_checks_disabled.' '.gettext('Hosts Disabled').'</a></div>';
		else
			$output.='<div class="tacfeatureNoProblem">'.gettext('All Hosts Enabled').'</div>';
		}
	$output.='</td>';
	
	// passive checks
	$output.='<td><a href="'.$process_status_url.'"><img src="'.theme_image(($passive_checks_enabled==0)?"tacdisabled.png":"tacenabled.png").'"></a></td>';
	$output.='<td width="135">';
	if($passive_checks_enabled==0){
		$output.='<div class="tacfeatureNoProblem">N/A</div>';
		}
	else{
		if($services_passive_checks_disabled>0)
			$output.='<div class="tacfeatureNoProblem"><a href="'.$status_url.'?show=services&serviceattr=16384">'.$services_passive_checks_disabled.' '.gettext('Services Disabled').'</a></div>';
		else
			$output.='<div class="tacfeatureNoProblem">'.gettext('All Services Enabled').'</div>';
		if($hosts_passive_checks_disabled>0)
			$output.='<div class="tacfeatureNoProblem"><a href="'.$status_url.'?show=hosts&hostattr=16384">'.$hosts_passive_checks_disabled.' '.gettext('Hosts Disabled').'</a></div>';
		else
			$output.='<div class="tacfeatureNoProblem">'.gettext('All Hosts Enabled').'</div>';
		}
	$output.='</td>';
	
	$output.='</tr>';

	$output.='
	</tbody>
	</table>
	';
	

	if($mode==DASHLET_MODE_INBOARD){
		$output.='
		<div class="ajax_date">'.gettext('Last Updated').': '.get_datetime_string(time()).'</div>
		';
		}
		
	//echo timer_stop($start); 	
	
	return $output;
	}

?>
